comment $
//-----------------------------------------------------------------------------------//
//  Source code                                                                      //
//                                                                                   //
//  Written      by  Chib                            			                     //
//                                                                                   //
//  FileName   : XXControls_DLL.asm                                                  // 
//  Description: libraries of functions for work with menu, button (DLL version)     //
//                                                                                   //
//  email      : XXControls@bk.ru                                                    //
//  website    : http://chib.boom.ru                                                 //
//-----------------------------------------------------------------------------------//
$
 
    .486
    .model flat, stdcall
    option casemap :none
    
    include XXCtrl.inc    
    
    include \masm32\XXControls\DLL_LIB_INC\INC\XXControls.inc

    include XXMenu.inc    
    include XXButton.inc

    include XXGrafics.asm  
    include XXMenu.asm
    
    include ToOwnerMenu.inc
    include Office_xp.inc
    include Office_2000.inc
    include XNET.inc    
    include Default.inc
    
    include ButtonStyles.inc
    include XXButton.asm
    include SubClassProc.asm 
    include Transparent.inc    
     
;--------------------------------------------------------------------------
.code

;===========================================================================;
; Name:     DllEntry                                                        ;
; Function: Performs an undo action (if any)                                ;
;                                                                           ;
; Params:   lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;

DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD

    .if reason==DLL_PROCESS_ATTACH                 ; DLL           
        m2m hInst, hInstance
                 
;    .elseif reason==DLL_PROCESS_DETACH             ; DLL 
;        
; 
;    .elseif reason==DLL_THREAD_ATTACH
;
;    .else        ; DLL_THREAD_DETACH

    .endif
    mov  eax, TRUE
    ret
DllEntry endp

end DllEntry