$invoke MACRO Fun:REQ, A:VARARG
  IFB <A>
    invoke Fun
  ELSE
    invoke Fun, A
  ENDIF
  EXITM <eax>
        ENDM       


GetRValue MACRO arg:REQ
    mov eax, arg
    and eax, 0ffh
endm <eax>

GetGValue MACRO arg:REQ
    mov eax, arg
    shr eax, 8
    and eax, 0ffh
endm <eax>

GetBValue MACRO arg:REQ
    mov eax, arg
    shr eax, 16
endm <eax>

$RGB MACRO red:req,green:req,blue:req
    EXITM %(((blue) SHL 16) OR ((green) SHL 8) OR (red))
ENDM

    ;; -----------------------------------
    ;; INPUT red, green & blue BYTE values
    ;; OUTPUT DWORD COLORREF value in eax
    ;; -----------------------------------
      RGB MACRO red, green, blue
        xor eax, eax
        mov al, blue    ; blue
        rol eax, 8
        mov al, green   ; green
        rol eax, 8
        mov al, red     ; red
      ENDM
      
      RGBQ MACRO red, green, blue
        xor eax, eax        
        mov al, red     ; red
        rol eax, 8       
        mov al, green   ; green
        rol eax, 8
        mov al, blue    ; blue
      ENDM      

MsgBox  macro   txt
    pusha
    invoke  MessageBox,NULL,txt,SZ("Infos..."),MB_ICONINFORMATION + MB_APPLMODAL
    popa
endm
 
MAKEDWORD MACRO LoWord,HiWord
    mov ax, HiWord
    ror eax, 16
    mov ax, LoWord
ENDM 
     
LOWORD macro bigword    ;     
   mov  eax,bigword
   and  eax,0FFFFh     ;; Set to low word 
endm


HIWORD macro bigword    ;    
   mov  eax,bigword
   shr  eax,16         ;; Get high word
endm

	mov1 macro a, b
		mov eax, b
		mov a, eax
	endm

	xora macro
		xor eax, eax
	endm

	xorb macro
		xor ebx, ebx
	endm

	xord macro
		xor edx, edx
	endm
	
     ;=============
      ; Local macros
      ;=============

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

IF_MSG macro WMsg:REQ, DoJmp:REQ
   cmp uMsg, WMsg
   jz  DoJmp
endm

WM_CASE macro reg,msgs
   irp msg,<msgs>
      cmp reg,WM_&msg
      je @@&msg
   endm
endm	

; MACROS for Dialogs.inc (in folder /masm32/include/dialogs.inc)

    ; --------------
    ; dialog window
    ; --------------
    
      DialogEx MACRO quoted_text_title,quoted_font,fsize,extyle,dstyle,ctlcnt,tx,ty,wd,ht,bsize
        push esi
        push edi
        invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,bsize
        mov esi, eax
        mov edi, esi
        mov DWORD PTR [edi+0],  DS_SETFONT or dstyle
        mov WORD  PTR [edi+4],  ctlcnt
        mov WORD  PTR [edi+8],  extyle
        m2m WORD  PTR [edi+10], tx
        m2m WORD  PTR [edi+12], ty
        m2m WORD  PTR [edi+14], wd
        m2m WORD  PTR [edi+16], ht
        add edi, 22
        ustring quoted_text_title
        mov WORD PTR [edi], fsize
        add edi, 2
        ustring quoted_font
      ENDM      
      
    ; ------------------------------------
    ; create a modal dialog from the data
    ; written to the memory template.
    ; ------------------------------------
      CallNotModalDialog MACRO Instance,Parent,DlgProc,lpExtra
        invoke CreateDialogIndirectParam,Instance,esi,Parent,
                                      ADDR DlgProc,lpExtra
        push eax                ;; preserve return value
        invoke GlobalFree,esi   ;; free memory
        pop eax                 ;; restore return value
        pop edi
        pop esi
      ENDM      