; #########################################################################
;                                                                         ;
;   WM_DrawItem ( 2000)                            ;
;                                                                         ;
; #########################################################################

DrawItem_Menu2000 proc uses edx ebx

    LOCAL RctIcon     :RECT  
    LOCAL RctEdge     :RECT
    LOCAL RctText     :RECT
    LOCAL RctSep      :RECT
    LOCAL RctLeftBorder:RECT
    LOCAL mii         :MENUITEMINFOM
    LOCAL mi          :MENUINFO
    LOCAl TextItemLen :DWORD
    LOCAL szBuff[max_len_menu_item] :BYTE
    LOCAL tSelect     :BYTE         ;        .
    LOCAL hIcon       :DWORD
    LOCAL hPenSep     :HPEN    ;        CheckItema    
    LOCAL OldPen      :HPEN    ;       
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar:COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF
;    LOCAL hMemDC      :HDC
    LOCAL hOldBmp     :DWORD
    LOCAL nX          :DWORD
    LOCAL nY          :DWORD
    LOCAL bm          :BITMAP
   
    LOCAL hBrushCheckUn :HBRUSH

    LOCAL fDrawState  :BYTE
    LOCAL tmp         :DWORD
    LOCAL WidthBorder :DWORD 
    
    LOCAL iconinfo    :ICONINFO   

   ; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    mov colorSep, $invoke ( GetSysColor, COLOR_GRAYTEXT )   
    call GetXpHighlightColor
    mov colorSel, eax

    invoke LightenColor, 96, colorMenuBar
    invoke CreateSolidBrush, eax
    mov hBrushCheckUn, eax 

; ======================================================================

assume ebx: ptr DRAWITEMSTRUCT

;         
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE ;or MIIM_STRING
    invoke GetMenuItemInfo, [ebx].hwndItem, [ebx].itemID, FALSE, ADDR mii
    m2m hIcon, mii.dwItemData    
  
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP    

    .if eax == MFT_STRING                  ;   STRING

        ; IsIcon
        invoke GetIconInfo, hIcon, ADDR iconinfo
        cmp eax, 0 
        jne @f
        mov hIcon, FALSE
@@:       
        mov mi.cbSize, sizeof (MENUINFO)
        mov mi.fMask, MIM_MENUDATA
        invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
        LOWORD mi.dwMenuData
        mov WidthBorder, eax
    
        inc [ebx].rcItem.top
        dec [ebx].rcItem.bottom
    
        invoke GetMenuString, [ebx].hwndItem, [ebx].itemID, ADDR szBuff, max_len_menu_item, MF_BYCOMMAND ;  
        mov TextItemLen, eax

        ;     (٨?)
    
        .if [ebx].itemState & ODS_GRAYED
                    
            invoke GetSysColor, COLOR_GRAYTEXT           
            
            .if fSelection                      ;     ?
                mov tSelect, TRUE
                
                .if [ebx].itemState & ODS_SELECTED                
                    ;        
                    mov edx, eax
                    invoke GetSysColor, COLOR_HIGHLIGHT                                       
                    .if edx == eax
                        invoke LightenColor, 96, eax
                        .if eax == edx
                            invoke DarkenColor, 96, eax                        
                        .endif
                    .else
                        mov eax, edx
                    .endif                
                .endif
                
            .else
                mov tSelect, FALSE
            .endif
        .else
            invoke GetSysColor, COLOR_MENUTEXT
            mov tSelect, TRUE
        .endif
        invoke SetTextColor, [ebx].hdc, eax
    
        .if [ebx].itemState & ODS_SELECTED
            cmp tSelect, 0
            je @f      
            
            .if hIcon || [ebx].itemState & ODS_CHECKED
                mov eax, WidthBorder
                inc eax
                add [ebx].rcItem.left, eax                                 
            .endif
            invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, COLOR_HIGHLIGHT+1
            
;            invoke FrameRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSelBor
            .if hIcon || [ebx].itemState & ODS_CHECKED
                mov eax, WidthBorder
                inc eax
                sub [ebx].rcItem.left, eax
            .endif
            
            
            mov fDrawState, SELECT
            .if !([ebx].itemState & ODS_GRAYED)
                invoke GetSysColor, COLOR_HIGHLIGHTTEXT
                invoke SetTextColor, [ebx].hdc, eax
            .endif                        
@@:
        .else
        
            dec [ebx].rcItem.top
            inc [ebx].rcItem.bottom
        
            invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, COLOR_MENU+1
            
            inc [ebx].rcItem.top
            dec [ebx].rcItem.bottom
            
            mov fDrawState, UNSELECT
        .endif
          
       .if [ebx].itemState & ODS_GRAYED
            mov fDrawState, GRAY
       .endif
        
       .if [ebx].itemState & ODS_CHECKED    ;           
           
            .if hIcon
            
                mov eax, [ebx].rcItem.left        ;   
                mov RctEdge.left, eax
                mov eax, [ebx].rcItem.top
                mov RctEdge.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthBorder
                mov RctEdge.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctEdge.bottom, eax
            
                .if fDrawState == GRAY
                    invoke DrawEdge, [ebx].hdc, ADDR RctEdge, BDR_SUNKENOUTER, BF_RECT
                .elseif fDrawState == SELECT
                    invoke InflateRect, ADDR RctEdge, -1, -1
                    invoke FillRect, [ebx].hdc, ADDR RctEdge, COLOR_MENU+1
                    invoke InflateRect, ADDR RctEdge, 1, 1
                    invoke DrawEdge, [ebx].hdc, ADDR RctEdge, BDR_SUNKENINNER, BF_TOPLEFT
                .elseif fDrawState == UNSELECT
                    invoke InflateRect, ADDR RctEdge, -1, -1
                    invoke FillRect, [ebx].hdc, ADDR RctEdge, hBrushCheckUn
                    invoke InflateRect, ADDR RctEdge, 1, 1
                    invoke DrawEdge, [ebx].hdc, ADDR RctEdge, BDR_SUNKENOUTER, BF_RECT
                .endif

                jmp icon_draw               
                
            .else
           
                ;              
                ;              
                mov eax, mii.fType
                and eax, MFT_RADIOCHECK
                .if eax == MFT_RADIOCHECK
                    mov al, TRUE
                .else
                    mov al, FALSE
                .endif
                
                
                
                invoke DrawCheck_2000, [ebx].hdc, ADDR [ebx].rcItem, WidthBorder, fDrawState, al
    
            .endif
    
       .else
       
            .if hIcon 
            
                .if [ebx].itemState & ODS_SELECTED && tSelect
            
                    mov eax, [ebx].rcItem.left        ;   Edge
                    mov RctEdge.left, eax
                    mov eax, [ebx].rcItem.top
                    mov RctEdge.top, eax
                    mov eax, [ebx].rcItem.left
                    add eax, WidthBorder
                    mov RctEdge.right, eax
                    mov eax, [ebx].rcItem.bottom
                    mov RctEdge.bottom, eax

                    invoke DrawEdge, [ebx].hdc, ADDR RctEdge, BDR_RAISEDINNER, BF_RECT
                    
                .endif

icon_draw:
                
                .if fDrawState == SELECT
                    mov fDrawState, UNSELECT
                .endif               
                 
                mov eax, [ebx].rcItem.left        ;   
                mov RctIcon.left, eax
                mov eax, [ebx].rcItem.top
                mov RctIcon.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthBorder
                mov RctIcon.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctIcon.bottom, eax     
                     
                invoke DrawIcnRect, [ebx].hdc, ADDR RctIcon, hIcon, fDrawState, TRUE    ; DRAW ICON
                
            .elseif mii.hbmpItem                    
                invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, fDrawState, WidthBorder                    
            .endif
                
       .endif

       .if TextItemLen
    
            ; 
       
                ;   
                invoke CopyRect, ADDR RctText, ADDR [ebx].rcItem
                mov eax, WidthBorder
                add RctText.left, eax
                add RctText.left, 4         ;         
                ;sub RctText.right, 5       ;        Tab     
           
            .if ([ebx].itemState & ODS_GRAYED) && !([ebx].itemState & ODS_SELECTED)
                invoke GetSysColor, COLOR_BTNHIGHLIGHT
                invoke SetTextColor, [ebx].hdc, eax
                
                inc RctText.left
                inc RctText.bottom
                inc RctText.right
                inc RctText.top
                mov tmp, 0                       
            .endif        
    
@@:         
            ;   
            HIWORD mi.dwMenuData              
            invoke DrawMenuString, [ebx].hdc, [ebx].hwndItem, ADDR szBuff, TextItemLen, ADDR RctText, eax        
            cmp tmp, 1
            je @f    
        
           .if ([ebx].itemState & ODS_GRAYED) && !([ebx].itemState & ODS_SELECTED)
                invoke GetSysColor, COLOR_BTNSHADOW
                invoke SetTextColor, [ebx].hdc, eax
                dec RctText.left
                dec RctText.bottom
                dec RctText.right
                dec RctText.top 
                
                mov tmp, 1            
                jmp @b           
            .endif
@@:

        .endif

        dec [ebx].rcItem.top
        inc [ebx].rcItem.bottom
        
   .elseif eax == MFT_SEPARATOR           ;   SEPARATOR
    
        .if hIcon
    
            invoke GetClipBox, [ebx].hdc, ADDR RctLeftBorder
            m2m RctLeftBorder.left, [ebx].rcItem.left
            m2m RctLeftBorder.right, [ebx].rcItem.right

            lea eax, RctLeftBorder
            push eax
            push [ebx].hdc
            push [ebx].hwndItem
            call hIcon

        .else    
    
            mov mi.cbSize, sizeof (MENUINFO)
            mov mi.fMask, MIM_MENUDATA
            invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
            LOWORD mi.dwMenuData
            mov WidthBorder, eax    
    
            invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1
            
            ; Draw the seperator             
            invoke CopyRect, ADDR RctSep, ADDR [ebx].rcItem
            
            mov eax, WidthBorder
            shr eax, 1
            inc eax
            add RctSep.left, eax        
            sub RctSep.right, eax
              
            mov eax, RctSep.bottom
            sub eax, RctSep.top
            shr eax, 1
            dec eax
            add RctSep.top, eax        
            m2m RctSep.bottom, RctSep.top
            add RctSep.bottom, 2
            
            invoke FillRect, [ebx].hdc, ADDR RctSep, COLOR_BTNHIGHLIGHT+1        
                    
            dec RctSep.right
            dec RctSep.bottom
            
            invoke FillRect, [ebx].hdc, ADDR RctSep, COLOR_BTNSHADOW+1
            
        .endif        
    
    .elseif eax == MFT_BITMAP              ;   BITMAP
    
    
    
    .endif
    
    invoke DeleteObject, hBrushCheckUn
    assume ebx: nothing
    ret
DrawItem_Menu2000 endp


DrawCheck_2000 proc uses edx hDC:HDC, lpRect:DWORD, WidthBorder:DWORD, State:BYTE, CheckMark:BYTE

LOCAL RctCheck              :RECT
LOCAL hBrushCheckDisabled   :HBRUSH
LOCAL hPenFrameGray         :HPEN      ;      CheckItema
LOCAL OldPen                :HPEN      ;     
LOCAL OldBrush              :HBRUSH
LOCAL hGlyphFont            :HFONT
LOCAL colorSel              :COLORREF
LOCAL colorBorder           :COLORREF
LOCAL GlyphArray[2]         :BYTE
LOCAL OldClr                :DWORD
LOCAL ncinfo                :NONCLIENTMETRICS
LOCAL hBrushCheckUn         :HBRUSH

    call NumColorBits
    .if eax > 8   
        invoke LightenColor, 128, $invoke ( GetSysColor, COLOR_GRAYTEXT )     ; 
        invoke CreateSolidBrush, eax
        mov hBrushCheckDisabled, eax    
        invoke GetSysColor, COLOR_MENU
        invoke LightenColor, 96, eax
        invoke CreateSolidBrush, eax
        mov hBrushCheckUn , eax
    .else
        invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_GRAYTEXT )
        mov hBrushCheckDisabled, eax
        invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_MENU )
        mov hBrushCheckUn , eax 
    .endif    
    
   ;     CheckItema.   
   
    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                              sizeof(NONCLIENTMETRICS),\
                              addr ncinfo, 0                                      ;  ,    
    
    .if ncinfo.lfMenuFont.lfHeight > -15
        mov ncinfo.lfMenuFont.lfHeight, -15
    .endif

;   mov ncinfo.lfMenuFont.lfWidth, 14

    mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
    
    invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
    invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
       
    mov hGlyphFont, eax             ;   
    
;    CheckItema
    
    invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )
    invoke CreatePen,PS_SOLID,1,eax
    mov hPenFrameGray, eax     

    mov edx, lpRect

;    invoke CopyRect, ADDR RctCheck, lpRect

    mov eax, [edx].RECT.left        ;   
    mov RctCheck.left, eax
    mov eax, [edx].RECT.top
    mov RctCheck.top, eax
    mov eax, [edx].RECT.left
    add eax, WidthBorder
    mov RctCheck.right, eax
    mov eax, [edx].RECT.bottom
    mov RctCheck.bottom, eax
    
    xor eax, eax                    ;  
    mov al, State 
    and al, GRAY or SELECT or UNSELECT

    .if al == GRAY
    
        mov OldClr, $invoke (SetTextColor, hDC, $invoke ( GetSysColor, COLOR_GRAYTEXT ))
        mov OldPen, $invoke ( SelectObject, hDC, hPenFrameGray )
        mov OldBrush, $invoke ( SelectObject, hDC, hBrushCheckDisabled )
        invoke DrawEdge, hDC, ADDR RctCheck, BDR_SUNKENOUTER, BF_RECT
        invoke SelectObject, hDC, OldPen    ;    ,                             
        invoke SelectObject, hDC, OldBrush  ;           

    .elseif al == SELECT

        mov OldClr, $invoke (SetTextColor, hDC, Black)
        invoke InflateRect, ADDR RctCheck, -1, -1
        invoke FillRect, hDC, ADDR RctCheck, COLOR_MENU+1
        invoke InflateRect, ADDR RctCheck, 1, 1
        invoke DrawEdge, hDC, ADDR RctCheck, BDR_SUNKENINNER, BF_TOPLEFT
                
    .elseif al == UNSELECT

        mov OldClr, $invoke (SetTextColor, hDC, Black)
        invoke InflateRect, ADDR RctCheck, -1, -1
        invoke FillRect, hDC, ADDR RctCheck, hBrushCheckUn
        invoke InflateRect, ADDR RctCheck, 1, 1
        invoke DrawEdge, hDC, ADDR RctCheck, BDR_SUNKENOUTER, BF_RECT
    
    .endif

    invoke SetBkMode,hDC,TRANSPARENT
    invoke SelectObject, hDC, hGlyphFont
    push eax
    
    .if CheckMark               
        mov GlyphArray, 69h         ; Bullet
    .else 
        mov GlyphArray, 62h         ; Checkmark
    .endif 
                               
    invoke DrawText, hDC,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER or DT_SINGLELINE
    pop eax
    invoke SelectObject,hDC, eax            ;   
    
    invoke SetTextColor, hDC, OldClr
    invoke DeleteObject, hGlyphFont
    invoke DeleteObject, hPenFrameGray
    invoke DeleteObject, hBrushCheckDisabled
    invoke DeleteObject, hBrushCheckUn
    
    ret
DrawCheck_2000 endp