comment $
//-----------------------------------------------------------------------------------//
//  Source code                                                                      //
//                                                                                   //
//  Written      by  Chib                            			                     //
//                                                                                   //
//  FileName   : SubClassProc.asm                                                    //
//  Description: functions for subclassing main window                               //
//                                                                                   //
//  email      : XXControls@bk.ru                                                    //
//  website    : http://chib.boom.ru                                                 //
//-----------------------------------------------------------------------------------//
$
    
;--------------------------------------------------------------------------
.code

; #########################################################################
;                                                                         ;
;                                             ;  
;                                                                         ;
; #########################################################################

SetNewWndProc proc hWin :HWND, szProp:DWORD, lpWndFunc:DWORD

    ;      
    ;          
    invoke GetProp, hWin, szProp
    .if !eax
        invoke SetWindowLong, hWin, GWL_WNDPROC, lpWndFunc
        invoke SetProp, hWin, szProp, eax
    .endif 

    ret
SetNewWndProc endp

; #########################################################################
;                                                                         ;
;                         ;
;                                                                         ;
; #########################################################################    

XXWndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL OldWndProc :DWORD
;LOCAL hMenuWnd   :DWORD

LOCAL Rct        :RECT
LOCAL pt         :POINT
LOCAL x_m        :DWORD
LOCAL y_m        :DWORD

    invoke GetProp, hWin, ADDR szProp_OldWndProc
    mov OldWndProc, eax
       
    .if uMsg == WM_DRAWITEM
        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam
        invoke DrawItem_Ctrl, lParam        ; Other controls
        ret     ;  eax == TRUE ? FALSE,        ( ), 
                ;     Win9X.

;    .elseif uMsg == WM_MEASUREITEM
;
;        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam
;        .if eax == FALSE
;    
;            .if !wParam    ; MENU? (wParam == 0 - only menu)
;    
;                invoke IsMenu, hMenuForMeasure
;                .if !eax
;                    mov eax, FALSE                
;                    jmp @f
;                .endif                
;                       
;                invoke MeasureItem_Menu, lParam            
;@@:
;     
;                return eax        
;            .endif
;            
;         .endif
;         return FALSE 

;    .elseif uMsg == WM_ENTERMENULOOP
;    
;;        PrintDec wParam, "WM_ENTERMENULOOP"
;        mov fAccel, FALSE
;        jmp  d_c     

    .elseif uMsg == WM_EXITMENULOOP
    
;        PrintDec wParam, "WM_EXITMENULOOP"
        
; *********FOR BUTTON******************          
          
        .if m_bMenuPushed

           call ReleaseCapture
           invoke InvalidateRect, m_bMenuPushed, NULL, TRUE
            
           invoke GetCursorPos, ADDR pt
           invoke GetWindowRect, m_bMenuPushed, ADDR Rct
           m2m x_m, Rct.left
           m2m y_m, Rct.bottom
           m2m Rct.left, Rct.right
           sub Rct.left, nDropBtnWidth 
           invoke PtInRect, ADDR Rct, pt.x, pt.y            
           
           .if eax
                mov m_bMenuPushed, 1
           .else            
                mov m_bMenuPushed, 0
           .endif 
        .endif         

; *************************************

;    .elseif uMsg == WM_SYSCOLORCHANGE

;        PrintDec wParam, "WM_SYSCOLORCHANGE"
;        jmp d_c
        
;    .elseif uMsg == WM_PARENTNOTIFY
;    
;        HIWORD wParam
;        .if eax == WM_CREATE        
;            .if fTransparent 
;                invoke GetWindowLong, lParam, GWL_EXSTYLE
;                .if !(eax & WS_EX_LAYERED)            
;                    or eax, WS_EX_LAYERED
;                    invoke SetWindowLong, lParam, GWL_EXSTYLE, eax
;                    invoke SetLayeredWindowAttributes, lParam, 0,200, LWA_ALPHA
;                .endif
;            .endif 
;
;        .endif
;    
;        jmp d_c    
        
;    .elseif uMsg == WM_DESTROY
;        invoke RemoveProp, hWin, ADDR szProp_OldWndProc      
;        invoke SetWindowLong, hWin, GWL_WNDPROC, OldWndProc
   
        jmp  d_c
    .else

d_c:        
        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam
        ret
    .endif           
 
    xor eax,eax
    ret
XXWndProc endp

; #########################################################################
;                                                                         ;
;    WM_DRAWITEM.                              ;
;                                                                         ;
; #########################################################################

DrawItem_Ctrl proc uses ebx esi lParam:LPARAM

    mov ebx, lParam
    assume ebx: ptr DRAWITEMSTRUCT

    .if [ebx].CtlType == ODT_BUTTON
    
        invoke GetProp, [ebx].hwndItem, ADDR szProp_Struct
        .if eax
            mov esi, eax
            call DrawItem_Btn
            mov eax, TRUE   
        .else
            mov eax, FALSE
        .endif
    
    .endif  

    assume ebx: nothing
    ret    
DrawItem_Ctrl endp